
		[Bindable]		
		[Embed(source="assets/images/thumb_on.png")]
		private var thumbOn:String;
		
		[Bindable]		
		[Embed(source="assets/images/thumb_off.png")]
		private var thumbOff:String;
		
		[Bindable]		
		[Embed(source="assets/images/list_on.png")]
		private var listOn:String;
		
		[Bindable]		
		[Embed(source="assets/images/list_off.png")]
		private var listOff:String;
		[Embed(source="assets/images/thumb_roll.png")]
		private var thumbRoll:String;
		[Embed(source="assets/images/list_roll.png")]
		private var listRoll:String;

    	import model.Product;
     	import mx.collections.*;
    	import mx.events.SliderEvent;
    	import mx.rpc.events.ResultEvent;

		[Bindable]
		private var catalog:ArrayCollection;
		
 		[Bindable]
		private var maxPriceSlider:Number;   		
    		
 		private function resultSessionHandler(event:ResultEvent):void  
		{
			var source:ArrayCollection = catalogConn.lastResult.catalog.product as ArrayCollection;
			var result:ArrayCollection = new ArrayCollection();
			// ---
			maxPriceSlider = -1;
	    	var cursor:IViewCursor = source.createCursor();
	   		while (!cursor.afterLast)
	    	{
	    		var product:Product = new Product();
	    		product.fill(cursor.current);
	        	result.addItem(product);
	        	// compute the max price for slider
	        	if (product.price > maxPriceSlider) maxPriceSlider = product.price;
	        	cursor.moveNext();
	    	}
	    	// --- compute maxPriceSlider
	    	maxPriceSlider = Math.round(maxPriceSlider+0.5);
	    	priceSlider.maximum = maxPriceSlider;
	    	priceSlider.values = [0, maxPriceSlider];
	    	priceSlider.labels = [0, maxPriceSlider];
	    	priceSlider.tickInterval = Math.round(maxPriceSlider/15);
	    	// 
	    	catalog = result;
		}
			
		// -- --
		[Bindable]
		public var selectedProduct:Product;
		public function doChangeHandler(event:Event):void {
			selectedProduct = event.target.selectedProduct as Product;
		}
		
		public function doCartChangeHandler(event:Event):void {
			unselect();
			selectedProduct = event.target.selectedProduct as Product;
		}
			
		// -- --		
  		public function doSortHandler(event:Event):void 
   		{
   			var sortBy:String = event.target.selectedItem;
     	    var newSort:Sort = new Sort();
   			if (sortBy=="Name") 
   			{
            	newSort.fields=[new SortField("name")];
      		}
            else 
            {
             	newSort.fields=[new SortField("price")];               	
            }
           	catalog.sort=newSort;
            //Refresh the collection view to show the sort.
            catalog.refresh();
       	}			
		// -- --
		public var minPrice:Number = 0;
		public var maxPrice:Number = 100000;
		private function filterPrice(item:Object):Boolean {
            return item.price >= minPrice && item.price < maxPrice;
        }
  		public function doFilterHandler(event:SliderEvent):void 
   		{
   			minPrice = priceSlider.values[0];
   			maxPrice = priceSlider.values[1];
   			catalog.filterFunction=filterPrice;
            //Refresh the collection view to show the sort.
            catalog.refresh();
       	}

		// -- --
		public function unselect(propagate:Boolean = false):void 
		{
			thumbView.unselect(propagate);
			gridView.unselect();	
		}
					
		// The "web service" request for the product catalog is sent when the application is initialized
		private function initApp():void 
		{
		    catalogConn.send();
		}
		
		// -- --	
		[Bindable]		
		public var currentView:String = "thumb";
		
		public function changeView(view:String):void {
		    currentView=view;
		    if (view=="thumb") {
		        bodyStack.selectedChild=thumbView;
		        controlStack.selectedChild=thumbCtrl;
		    } else if (view=="grid") {
		        bodyStack.selectedChild=gridView;
		        controlStack.selectedChild=gridCtrl;
		    } else if (view=="checkout") {
		   		bodyStack.selectedChild=checkoutView;
		        controlStack.selectedChild=checkoutCtrl;
		    }
		}
		// --- ---
		import eventstore.ResizeEvent;
		import mx.effects.Resize;

		private function slide(event:ResizeEvent):void {
			var e:Resize = new mx.effects.Resize(topCanvas);
			if (event.size=="medium") {
			    e.heightTo=325;
			    statusTop.selected="medium";
			    statusBottom.selected="medium";
			} else if (event.size=="small") {
			    if (event.target==statusTop) {
			        e.heightTo=30;
			        statusTop.selected="small";
			        statusBottom.selected="large";
			    } else {
			        e.heightTo = hb.height - 36;
			        statusTop.selected="large";
			        statusBottom.selected="small";
			    }
			} else {
			    if (event.target==statusTop) {
			        e.heightTo = hb.height - 36;
			        statusTop.selected="large";
			        statusBottom.selected="small";
			    } else {
			        e.heightTo=30;
			        statusTop.selected="small";
			        statusBottom.selected="large";
			    }
			}
			e.duration=300;
			e.play();
		}
